package com.extremelogic.common.jclap;

/**
 * @author Jan So (extreme.logic at yahoo.com)
 */
public class ArgumentFlagWrapper {

    /**
     * Delimiter string length.
     */
    private int delimiterLen = 0;

    /**
     * Delimiter value to identify options.
     */
    private String delimiter = "";

    /**
     * Value holder for the option provided.
     */
    private String flag;

    /**
     * Identifies delimiter if exists.
     */
    private boolean hasDelimiter = false;

    /**
     * @param delimiter The delimiter for the option
     * @param inFlag The option without the delimiter
     */
    protected ArgumentFlagWrapper(final String delimiter, final String inFlag) {

        this.delimiterLen = delimiter.length();
        if (inFlag.contains(delimiter)) {
            this.delimiter = inFlag.substring(0, this.delimiterLen);
            this.flag = inFlag.substring(this.delimiterLen, inFlag.length());
        }

        if (this.delimiter.equals(delimiter)) {
            hasDelimiter = true;
        }
    }

    /**
     * @return the string option
     */
    protected String getFlag() {
        return this.flag;
    }

    /**
     * @return the delimiter
     */
    protected String getDelimiter() {
        return this.delimiter;
    }

    /**
     * @return <code>true</code> if it has a delimiter; else <code>false</code>
     */
    protected boolean hasDelimiter() {
        return this.hasDelimiter;
    }
}