package com.extremelogic.common.jclap;

/**
 * @author Jan So (extreme.logic at yahoo.com)
 */
public class ArgumentRetriever {
    /**
     * List of arguments.
     */
    private ArgumentValueMap valueList;

    /**
     * @param valueList list of arguments
     */
    public ArgumentRetriever(final ArgumentValueMap valueList) {
        this.valueList = valueList;
    }

    /**
     * @param option to be checked
     * @return <code>true</code> if option exists; else <code>false</code>
     */
    public boolean hasOption(final String option) {
        boolean hasOption = false;

        hasOption = valueList.containsKey(option);

        return hasOption;
    }

    /**
     * @param option to key to retrieve value
     * @return the string value associated with the provided option
     */
    public String getOptionValue(final String option) {
        Object obj = null;
        String s1 = null;
        String[] s2 = null;

        obj = valueList.get(option);

        if (obj instanceof String) {
            s1 = (String) obj;
        } else if (obj instanceof String[]) {
            s2 = (String[]) obj;
            s1 = s2[0];
        } else if (obj instanceof Boolean) {
            Boolean b = (Boolean) obj;
            s1 = b.toString();
        }
        return s1;
    }

    /**
     * @param option to key to retrieve value
     * @return the string[] value associated with the provided option
     */
    public String[] getOptionValues(final String option) {
        Object obj = null;
        String s1 = null;
        String[] s2 = null;

        obj = valueList.get(option);

        if (obj instanceof String) {
            s1 = (String) obj;
            s2 = new String[1];
            s2[0] = s1;
        } else if (obj instanceof String[]) {
            s2 = (String[]) obj;
        }
        return s2;
    }
}
