package com.extremelogic.common.jclap.exception;

/**
 * @author Jan So (extreme.logic at yahoo.com)
 */
public class ArgumentInvalidException extends ArgumentException {
    /**
     * Eclipse generated UID.
     */
    private static final long serialVersionUID = 2883205153652531878L;

    /**
     * @param message The exception message
     */
    public ArgumentInvalidException(final String message) {
        super(message);
    }

    /**
     * @param invalidWhat The invalid description
     * @param invalidValue The actual invalid value
     * @param expecting The expected value
     */
    public ArgumentInvalidException(final String invalidWhat,
        final String invalidValue, final String expecting) {
        this(createMessage(invalidWhat, invalidValue, expecting));
    }

    /**
     * @param invalidWhat The invalid description
     * @param invalidValue The actual invalid value
     */
    public ArgumentInvalidException(final String invalidWhat,
        final String invalidValue) {
        this(createMessage(invalidWhat, invalidValue));
    }

    /**
     * @param invalidWhat The invalid description
     * @param invalidValue The actual invalid value
     * @param expecting The expected value
     * @return The message with "invalid" and "expecting" key words
     */
    private static String createMessage(final String invalidWhat,
        final String invalidValue, final String expecting) {
        StringBuffer sb = new StringBuffer();
        sb.append(createMessage(invalidWhat, invalidValue));
        sb.append(" Expecting [");
        sb.append(expecting);
        sb.append("]");

        return sb.toString();
    }

    /**
     * @param invalidWhat The invalid description
     * @param invalidValue The actual invalid value
     * @return The message with "invalid" and "expecting" key words
     */
    private static String createMessage(final String invalidWhat,
        final String invalidValue) {
        StringBuffer sb = new StringBuffer();
        sb.append("Invalid ");
        sb.append(invalidWhat);
        sb.append(" [");
        sb.append(invalidValue);
        sb.append("]");

        return sb.toString();
    }
}
